var SoftmodemAssistant = Class.create({
	put: function(t) {
		var el = $('console');
		el.innerHTML = el.innerHTML + t + '<br />';
	},
	setup: function() {
		// listen for activate/deactivate to forward to spinner plugin
		this.stageDocument = this.controller.stageController.document;
		Mojo.Event.listen(this.stageDocument, Mojo.Event.stageActivate, this.handleStageActivate);
		Mojo.Event.listen(this.stageDocument, Mojo.Event.stageDeactivate, this.handleStageDeactivate);

		this.controller.setupWidget("sliderId", 
					    this.attributes = { 
								'minValue': 0,
								'maxValue': 100,
								'value': 10, 
								'updateInterval': 0.1 
                        });
		Mojo.Event.listen($("sliderId"), Mojo.Event.propertyChange, this.handleSlider.bind(this));

		// Set-up a JS function that can be called from within JS...
		// this.controller.listen($("softmodemPlugin"), 'testEvent', this.testFunc.bindAsEventListener(this));
		// $('softmodemPlugin').addEventListener('testEvent', testFunc, false);
		$('softmodemPlugin').testFunc = this.testFunc.bind(this);


		// Buttons...
		// Bind handler's "this" to our "that"
		var that = this;

		this.sendModel = {
			value: "Hello World",
			disabled: false
		};
		this.controller.setupWidget("sendField",
			this.attributes = {
				hintText: "Your text",
				multiline: false,
				enterSubmits: true,
				focus: true
			},
			this.model = this.sendModel
		);
		
		this.controller.setupWidget("sendButton",
			this.attributes = {},
			this.model = {
				label: "Send",
				buttonClass: "affirmative",	//"secondary",
				disabled: false
			}
		);
		this.controller.listen(this.controller.get("sendButton"), Mojo.Event.tap, this.handleSendTap.bindAsEventListener(this));
		
		//this.controller.document.addEventListener("keydown", this.handleKeypress.bindAsEventListener(this), true);
		
		this.put("Hello.");
  	},

	// This function is exposed to the plugin!
	testFunc: function(a, b) {
		this.put("testFunc(): " + String(a) + "-" + String(b));
		return "wootage!";
	},
	
	
	handleSlider: function(event) {
		this.put("handleSlider()...");
		try {
			var result = $('softmodemPlugin').setAngle(event.value);
			if ( result == null ) {
				this.put("plugin result is null");
			} else {
				this.put("plugin result: "+result);
			}
		} catch(e) {
			this.put("plugin exception: "+e);
		}
	},

	handleStageActivate: function(event) {
		//$('softmodemPlugin').resume();
	},
	
	handleStageDeactivate: function(event) {
		//$('softmodemPlugin').pause();
	},
	
	handleSendTap: function(event) {
		this.put("handleSendTap(): Sending " + this.sendModel.value + "...");
		
		try {
			var result = $('softmodemPlugin').sendData(this.sendModel.value);
			if ( result == null ) {
				this.put("plugin result is null");
			} else {
				this.put("plugin result: "+result);
			}
		} catch(e) {
			this.put("plugin exception: "+e);
		}
		
		this.sendModel.value = "";
		this.controller.modelChanged(this.sendModel);
		
		this.put("OK");
	}
}
);


