/*

 Synthia, Copyright 2003-2010 Bernhard Slawik, http://www.bernhardslawik.de

*/

#ifndef _SOFTMODEM_H
#define _SOFTMODEM_H

#define SOFTMODEM_SAMPLERATE 29400
#define SOFTMODEM_BAUD 1225
#define SOFTMODEM_FRQ_HI 7350
#define SOFTMODEM_FRQ_LO 4900

// Samples per Bit = SAMPLERATE / BAUD
#define SOFTMODEM_SPB 24

#define SOFTMODEM_BITS_PER_SYMBOL 10

// 49 bits
#define SOFTMODEM_CARRIER_PRE ceil(SOFTMODEM_SAMPLERATE*40/1000/SOFTMODEM_SPB)

// 6.125 bits => 7 bits
#define SOFTMODEM_CARRIER_POST ceil(SOFTMODEM_SAMPLERATE*5/1000/SOFTMODEM_SPB)

#define SOFTMODEM_MAX_BYTES 256
#define SOFTMODEM_FULLBUFFER_SAMPLES (SOFTMODEM_SPB*(SOFTMODEM_CARRIER_PRE+(SOFTMODEM_BITS_PER_SYMBOL*SOFTMODEM_MAX_BYTES)+SOFTMODEM_CARRIER_POST))*2

#include <stdio.h>
#include <math.h>
#include <sstream>
using namespace std;
#ifdef WIN32
	#include <windows.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include "SDL.h"
#include "PDL.h"

//Sint8 *softmodem_render(Sint8 *buffer, int len, int interval);
void softmodem_start();
void softmodem_stop();
void softmodem_queueData(char *data, int len);
void softmodem_fillBuffer(void *buffer, int samples);
int softmodem_isActive();


#endif