@echo off

@rem if run in the windows script folder, change to parent
if not exist plugin ( pushd .. ) else pushd .

@rem Set the device you want to build for to 1
set PRE=1
set PIXI=0
set DEBUG=0

@rem List your source files here
set SRC=plugin/softmodem_plugin.cpp plugin/softmodem.cpp

@rem List the libraries needed
REM set LIBS=-lSDL -lGLESv2 -lpdl -lm
set LIBS=-lSDL -lSDL_mixer -lpdl -lSDL_ttf -lGLESv2

@rem Name your output executable
set OUTFILE=softmodem_plugin
if %PRE% equ 0 if %PIXI% equ 0 goto :END

if %DEBUG% equ 1 (
   set DEVICEOPTS=-g
) else (
   set DEVICEOPTS=
)

if %PRE% equ 1 (
   set DEVICEOPTS=%DEVICEOPTS% -mcpu=cortex-a8 -mfpu=neon -mfloat-abi=softfp
)

if %PIXI% equ 1 (
   set DEVICEOPTS=%DEVICEOPTS% -mcpu=arm1136jf-s -mfpu=vfp -mfloat-abi=softfp
)

echo %DEVICEOPTS%
REM * For production: Add "-s" to strip debug symbols. Or else it won't be accepted into the AppCatalog!
REM * Remember to undef DEBUG in SDL_vnc.c!
arm-none-linux-gnueabi-gcc %DEVICEOPTS% -o %OUTFILE% %SRC% "-I%PALMPDK%\include" "-I%PALMPDK%\include\SDL" "-L%PALMPDK%\device\lib" -Wl,--allow-shlib-undefined %LIBS%

popd
goto :EOF

:END
echo Please select the target device by editing the PRE/PIXI variable in this file.
popd
exit /b 1

